
/*--------------------------------------------------------*/

/*
 * @file
 * @author Ravi Reddy Manumachu <ravi.manumachu@ucd.ie>
 * @version 1.0
 */

/*--------------------------------------------------------*/

#include <cstdlib>

/*--------------------------------------------------------*/

namespace hcl {

/*--------------------------------------------------------*/

size_t getDeviceMemory(int device);

/*--------------------------------------------------------*/

int summer(const int* array, int size);

/*--------------------------------------------------------*/

int matrixSplitSingleExceed(const int M, const int N, const int K,
                            const size_t coreMemSize, int* h_, int* w_,
                            int** height, int** width);

/*--------------------------------------------------------*/

int matrixSplitMultigpuExceed(const int M, const int N, const int K,
                              const size_t coreMemSize,
                              const int num_device_use, int* h_, int* w_,
                              int** height, int** width);

/*--------------------------------------------------------*/

template <typename T>
T* getBaddrFromIndex(const T* ptr, const int i, const int j, const int* height,
                     const int* width, const int N, const int K,
                     const int flag);

/*--------------------------------------------------------*/

template <typename T>
T* getBaddr1DFromIndex(const T* ptr, const int i, const int j,
                       const int* height, const int* width, const int h_,
                       const int w_, const int K, const int flag);

/*--------------------------------------------------------*/
}

/*--------------------------------------------------------*/
